import 'package:flutter/material.dart';
import 'package:loyalty_management_tool/utils/colors.dart';
import 'package:loyalty_management_tool/utils/hexColors.dart';

class CircleButton extends StatelessWidget {
  final IconData iconData;
  final double size;
  final double iconsize;
  final Color? color;

  const CircleButton(
      {Key? key,
      required this.iconData,
      this.size = 20,
      this.iconsize = 16,
      this.color})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      width: size,
      height: size,
      decoration: BoxDecoration(
        color: color ?? HexColor(AppColors.appMainColor),
        shape: BoxShape.circle,
      ),
      child: Icon(
        iconData,
        size: iconsize,
        color: HexColor(AppColors.appColorBlack85),
      ),
    );
  }
}
