import 'package:flutter/material.dart';

import '../../utils/app_buttons.dart';
import '../../utils/colors.dart';
import '../../utils/commonComponents.dart';
import '../../utils/hexColors.dart';
import '../../utils/text_styling.dart';

// ignore: must_be_immutable
class appTabButton extends StatelessWidget {
  bool isActive;
  Function onPressed;
  String? tabName;
  late TextStyleElements styleElements;

  appTabButton(
      {required this.isActive, required this.onPressed, required this.tabName});

  @override
  Widget build(BuildContext context) {
    styleElements = TextStyleElements(context);

    return Container(
      decoration: BoxDecoration(
        borderRadius: BorderRadius.circular(45.0),
        boxShadow: [CommonComponents().getShadowforBox()],
      ),
      child: appElevatedButton(
        elevation: 0,
        shape: StadiumBorder(
            side: BorderSide(
                color: isActive
                    ? HexColor(AppColors.appMainColor)
                    : HexColor(AppColors.appColorWhite))),
        onPressed: onPressed,
        child: Text(
          tabName!,
          style: styleElements.captionThemeScalable(context).copyWith(
              color: isActive
                  ? HexColor(AppColors.appColorWhite)
                  : HexColor(AppColors.appMainColor)),
        ),
        color: isActive
            ? HexColor(AppColors.appMainColor)
            : HexColor(AppColors.appColorWhite),
      ),
    );
  }
}
