import 'dart:async';
import 'dart:collection';
import 'dart:convert';

import 'package:flutter/material.dart';

import 'package:loyalty_management_tool/utils/localization.dart';

import 'package:shared_preferences/shared_preferences.dart';

import '../../../NetworkFile/calls.dart';
import '../../../models/base_response.dart';
import '../../../models/business_location.dart';
import '../../../models/countries.dart';
import '../../../models/language_list.dart';
import '../../../models/location_reponse_data.dart';
import '../../../models/states.dart';
import '../../../utils/basicInfo.dart';
import '../../../utils/colors.dart';
import '../../../utils/custom_app_bar.dart';
import '../../../utils/customcard.dart';
import '../../../utils/hexColors.dart';
import '../../../utils/text_styling.dart';
import '../../../utils/toast_builder.dart';
import 'country_page.dart';
import 'directions.dart';

// ignore: must_be_immutable
class BusinessLocationAddressPage extends StatefulWidget {
  final Function refreshCallBack;

  BusinessLocationAddressPage(this.refreshCallBack);

  @override
  _BusinessLocationAddressPage createState() =>
      new _BusinessLocationAddressPage();
}

class _BusinessLocationAddressPage extends State<BusinessLocationAddressPage>
    with SingleTickerProviderStateMixin {
  String? facebookId;
  String? googleSignInId;
  String? userName;
  String? imageUrl;
  bool? isEvent;
  var range = <String>[];
  var rangeStudent = <String>[];
  TextEditingController controller2 = TextEditingController();
  TextEditingController controllerLocation = TextEditingController();
  var businessTypelist = <String>[];
  var relationship = <String?>[];
  var mapCountry = HashMap<String, String>();
  var mapState = HashMap<String?, String?>();
  bool isTermAndConditionAccepted = false;
  String email = "";
  bool isGoogleOrFacebookDataReceived = false;
  double startPos = -1.0;
  double endPos = 1.0;
  Curve curve = Curves.elasticOut;
  final cityMapController = TextEditingController();
  final pinController = TextEditingController();
  final addController = TextEditingController();
  final fromMapController = TextEditingController();
  late BuildContext context;
  late TextStyleElements styleElements;
  double? lat, lon;
  BasicInfo? basicInfo = BasicInfo();

  bool isLoading = false;
  String? selectState;
  var country;
  var state;
  String? selectCountry = "Select Country";

  String? selectStRange;

  String? selectTecRange;
  int? selectedEpoch;

  late SharedPreferences prefs;

  bool isEdit = false;

  @override
  void initState() {
    super.initState();
    getBusinessType();
    setSharedPreferences();
    WidgetsBinding.instance!.addPostFrameCallback((_) => getDataLocation());
  }

  void setSharedPreferences() async {
    prefs = await SharedPreferences.getInstance();
  }

  String quotesCharacterLength = "0";
  String addresses = "address";

  @override
  Widget build(BuildContext context) {
    this.context = context;
    styleElements = TextStyleElements(context);
    List<DropdownMenuItem> relationType = [];
    _getRelationtype() {
      for (int i = 0; i < relationship.length; i++) {
        relationType.add(DropdownMenuItem(
          child: Text(
            relationship[i]!,
            style: styleElements.bodyText2ThemeScalable(context),
          ),
          value: relationship[i],
        ));
      }
      return relationType;
    }

    final pinZIp = Form(
        child: TextFormField(
      style: styleElements
          .subtitle1ThemeScalable(context)
          .copyWith(color: HexColor(AppColors.appColorBlack65)),
      onSaved: (String? value) {},
      controller: pinController,
      keyboardType: TextInputType.number,
      decoration: InputDecoration(
        hintText: AppLocalizationsRewards.of(context)!.translate('pin_zip'),
        contentPadding: EdgeInsets.only(left: 12, top: 16, bottom: 8),
        border: UnderlineInputBorder(borderRadius: BorderRadius.circular(12)),
        floatingLabelBehavior: FloatingLabelBehavior.auto,
        labelText: AppLocalizationsRewards.of(context)!.translate('pin_zip'),
      ),
    ));

    final completeAddress = Form(
        child: TextFormField(
      keyboardType: TextInputType.multiline,
      maxLines: null,
      style: styleElements
          .subtitle1ThemeScalable(context)
          .copyWith(color: HexColor(AppColors.appColorBlack65)),
      onSaved: (String? value) {},
      controller: controller2,
      decoration: InputDecoration(
        hintText:
            AppLocalizationsRewards.of(context)!.translate('complete_address'),
        border: InputBorder.none,
        contentPadding: EdgeInsets.only(left: 12, top: 16, bottom: 8),
      ),
    ));

    final locationSelect = Form(
        child: TextFormField(
      enabled: false,
      style: styleElements
          .subtitle1ThemeScalable(context)
          .copyWith(color: HexColor(AppColors.appColorBlack65)),
      onSaved: (String? value) {},
      controller: controllerLocation,
      decoration: InputDecoration(
        hintText:
            AppLocalizationsRewards.of(context)!.translate('location_select'),
        border: InputBorder.none,
        contentPadding: EdgeInsets.only(left: 12, top: 16, bottom: 8),
      ),
    ));

    final cityTown = Form(
        child: TextFormField(
      style: styleElements
          .subtitle1ThemeScalable(context)
          .copyWith(color: HexColor(AppColors.appColorBlack65)),
      onSaved: (String? value) {},
      controller: cityMapController,
      decoration: InputDecoration(
        hintText: AppLocalizationsRewards.of(context)!.translate('city_town'),
        contentPadding: EdgeInsets.only(left: 12, top: 16, bottom: 8),
        border: UnderlineInputBorder(borderRadius: BorderRadius.circular(12)),
        floatingLabelBehavior: FloatingLabelBehavior.auto,
        labelText: AppLocalizationsRewards.of(context)!.translate('city_town'),
      ),
    ));
    styleElements = TextStyleElements(context);

    final country = GestureDetector(
      onTap: () async {
        var result = await Navigator.push(
            context,
            MaterialPageRoute(
                builder: (BuildContext context) => CountryPage()));

        if (result != null) {
          LanguageItem languageItem = result["result"] as LanguageItem;
          selectCountry = languageItem.languageName;
          setState(() {
            selectState = null;
          });
          getRelationType(languageItem.languageCode, false, "");
        }
      },
      child: Container(
        color: HexColor(AppColors.appColorWhite),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Padding(
              padding: const EdgeInsets.only(top: 20.0, left: 22),
              child: Text(
                selectCountry!,
                style: styleElements
                    .bodyText2ThemeScalable(context)
                    .copyWith(color: HexColor(AppColors.appColorBlack65)),
              ),
            ),
            Padding(
              padding: const EdgeInsets.only(top: 8.0),
              child: Divider(
                color: HexColor(AppColors.appMainColor33),
                thickness: 1,
              ),
            )
          ],
        ),
      ),
    );

    final state = DropdownButtonFormField<dynamic>(
      value: null,
      isExpanded: true,
      decoration: InputDecoration(
          contentPadding: EdgeInsets.fromLTRB(20.0, 15.0, 2.0, 15.0)),
      hint: Padding(
        padding: const EdgeInsets.only(left: 0),
        child: Text(
          selectState ?? "State",
          style: styleElements.bodyText2ThemeScalable(context),
          maxLines: 1,
          overflow: TextOverflow.ellipsis,
        ),
      ),
      items: _getRelationtype(),
      onChanged: (value) {
        setState(() {
          selectState = value;
        });
      },
    );

    return WillPopScope(
      onWillPop: _onBackPressed,
      child: SafeArea(
          child: Scaffold(
              // resizeToAvoidBottomInset: false,
              appBar: appAppBar().getCustomAppBar(context,
                  appBarTitle: "Address",
                  isIconVisible: true,
                  actions: [
                    Padding(
                      padding: const EdgeInsets.all(16.0),
                      child: GestureDetector(
                        behavior: HitTestBehavior.translucent,
                        onTap: () {
                          submit(context);
                        },
                        child: Row(
                          children: [
                            Wrap(
                              direction: Axis.horizontal,
                              crossAxisAlignment: WrapCrossAlignment.center,
                              children: [
                                Text(
                                  AppLocalizationsRewards.of(context)!
                                      .translate('next'),
                                  style: styleElements
                                      .headline6ThemeScalableW(context)
                                      .copyWith(
                                          color: HexColor(AppColors.blueApp)),
                                ),
                                Icon(Icons.keyboard_arrow_right,
                                    color: HexColor(AppColors.blueApp))
                              ],
                            ),
                            Visibility(
                              visible: isLoading,
                              child: Padding(
                                padding: const EdgeInsets.all(4.0),
                                child: SizedBox(
                                  height: 15,
                                  width: 15,
                                  child: CircularProgressIndicator(),
                                ),
                              ),
                            )
                          ],
                        ),
                      ),
                    )
                  ], onBackButtonPress: () {
                Navigator.pop(context);
              }),
              body: Stack(
                children: [
                  SingleChildScrollView(
                    child: Visibility(
                        visible: !isGoogleOrFacebookDataReceived,
                        child: appCard(
                          child: Column(
                            children: <Widget>[
                              Align(
                                  alignment: Alignment.centerLeft,
                                  child: Container(
                                    margin: EdgeInsets.only(
                                        left: 8, right: 8, bottom: 8),
                                    child: Text(
                                      AppLocalizationsRewards.of(context)!
                                          .translate('location'),
                                      style: styleElements
                                          .headline6ThemeScalable(context)
                                          .copyWith(
                                              fontWeight: FontWeight.bold),
                                    ),
                                  )),
                              Container(
                                height: 50,
                                width: double.infinity,
                                margin: const EdgeInsets.only(
                                    left: 8.0, right: 8.0),
                                decoration: BoxDecoration(
                                    border: Border.all(
                                      color: HexColor(AppColors.appMainColor33),
                                    ),
                                    borderRadius:
                                        BorderRadius.all(Radius.circular(8))),
                                child: Row(
                                  mainAxisSize: MainAxisSize.min,
                                  crossAxisAlignment: CrossAxisAlignment.center,
                                  mainAxisAlignment:
                                      MainAxisAlignment.spaceBetween,
                                  children: [
                                    Expanded(child: locationSelect),
                                    Padding(
                                      padding: const EdgeInsets.all(8.0),
                                      child: InkWell(
                                        onTap: () async {
                                          var result = await Navigator.push(
                                              context,
                                              MaterialPageRoute(
                                                builder: (context) => MapPage(
                                                    isEdit: true,
                                                    lat: lat,
                                                    long: lon),
                                              ));

                                          if (result != null) {
                                            if (result["address"] != null) {
                                              controllerLocation.text =
                                                  result["address"];
                                            }
                                            controller2.text =
                                                result["address"];
                                            lat = result["lat"];
                                            lon = result["lon"];
                                            setState(() {});
                                          }
                                        },
                                        child: Text(
                                          AppLocalizationsRewards.of(context)!
                                              .translate(lat != null && lat != 0
                                                  ? 'change'
                                                  : "select"),
                                          style: styleElements
                                              .headline6ThemeScalable(context)
                                              .copyWith(
                                                  fontWeight: FontWeight.bold,
                                                  color: HexColor(
                                                      AppColors.appMainColor)),
                                        ),
                                      ),
                                    ),
                                  ],
                                ),
                              ),
                              Padding(
                                padding: const EdgeInsets.only(top: 8.0),
                                child: Container(
                                    height: 100,
                                    width: double.infinity,
                                    margin: const EdgeInsets.only(
                                        left: 8.0, right: 8.0),
                                    decoration: BoxDecoration(
                                        border: Border.all(
                                          color: HexColor(
                                              AppColors.appMainColor33),
                                        ),
                                        borderRadius: BorderRadius.all(
                                            Radius.circular(8))),
                                    child: completeAddress),
                              ),
                              Align(
                                  alignment: Alignment.center,
                                  child: Container(
                                    margin: EdgeInsets.only(
                                        left: 8, right: 8, bottom: 8),
                                    child: country,
                                  )),
                              Visibility(
                                visible: selectCountry != null &&
                                    selectCountry != "Select Country",
                                child: Align(
                                    alignment: Alignment.center,
                                    child: Container(
                                      margin: EdgeInsets.only(
                                          left: 8, right: 8, bottom: 8),
                                      child: state,
                                    )),
                              ),
                              Align(
                                  alignment: Alignment.center,
                                  child: Container(
                                    margin: EdgeInsets.only(
                                        left: 8, right: 8, bottom: 8),
                                    child: cityTown,
                                  )),
                              Align(
                                  alignment: Alignment.center,
                                  child: Container(
                                    margin: EdgeInsets.only(
                                        left: 8, right: 8, bottom: 8),
                                    child: pinZIp,
                                  )),
                            ],
                          ),
                        )),
                  ),
                ],
              ))),
    );
  }

  // ignore: missing_return
  Future<bool> _onBackPressed() {
    return new Future(() => true);
  }

  void getBusinessType() async {
    prefs = await SharedPreferences.getInstance();
    Calls()
        .calWithoutToken("", context, basicInfo!.countries)
        .then((value) async {
      if (value != null) {
        var data = Country.fromJson(value);

        for (var item in data.rows!) {
          businessTypelist.add(item[1].toString());

          mapCountry.putIfAbsent(item[1].toString(), () => item[0].toString());
        }
        setState(() {});
      }
    }).catchError((onError) {
      ToastBuilder().showToast(
          onError.toString(), context, HexColor(AppColors.information));
    });
  }

  void getRelationType(String? code, bool isEdit, String? stateCode) async {
    if (code != null) {
      final body = jsonEncode({
        "country": code,
      });

      Calls()
          .calWithoutToken(body, context, basicInfo!.states)
          .then((value) async {
        if (value != null) {
          relationship.clear();
          mapState.clear();
          var data = States.fromJson(value);
          for (var item in data.rows!) {
            relationship.add(item.name);
            mapState.putIfAbsent(item.name, () => item.code);

            if (isEdit) {
              if (stateCode != null && item.code == stateCode) {
                setState(() {
                  selectState = item.name;
                  state = item.name;
                });
              }
            }
          }
          setState(() {});
        }
      }).catchError((onError) {
        ToastBuilder().showToast(
            onError.toString(), context, HexColor(AppColors.information));
      });
    }
  }

  getDataLocation() async {
    var body = jsonEncode({"business_id": basicInfo!.businessId});

    Calls().call(body, context, basicInfo!.location).then((value) {
      var res = LocationDetailsResponse.fromJson(value);

      if (res.statusCode == basicInfo!.statusCode) {
        if (res.rows != null && res.rows!.isNotEmpty) {
          if (res.rows![0].streetAddress != null) {
            isEdit = true;
            controller2.text = res.rows![0].streetAddress!;
            controllerLocation.text = res.rows![0].streetAddress!;
          }

          if (res.rows![0].postalCode != null) {
            isEdit = true;
            pinController.text = res.rows![0].postalCode!;
          }

          if (res.rows![0].city != null) {
            isEdit = true;
            cityMapController.text = res.rows![0].city!;
          }

          if (res.rows![0].name != null) {
            isEdit = true;
            selectState = res.rows![0].name;
            state = res.rows![0].name;
            lat = double.parse(res.rows![0].latitude ?? "0");
            lon = double.parse(res.rows![0].longitude ?? "0");
            setState(() {});
          }
          setState(() {});
          getCountryList(res.rows![0].country!, res.rows![0].region ?? null);
        }
      }
    });
  }

  void getCountryList(String code, String? sCode) async {
    final body = jsonEncode({});
    Calls()
        .calWithoutToken(body, context, basicInfo!.countries)
        .then((value) async {
      if (value != null) {
        var data = Country.fromJson(value);
        if (this.mounted) {
          for (int i = 0; i < data.rows!.length; i++) {
            if (data.rows![i][0] == code) {
              LanguageItem languageItem = LanguageItem();
              languageItem.languageCode = data.rows![i][0];
              languageItem.languageName = data.rows![i][1];
              languageItem.isSelected = false;
              selectCountry = languageItem.languageName;
              country = languageItem.languageName;

              setState(() {
                getRelationType(languageItem.languageCode, true, sCode);
              });
            }
          }
          setState(() {});
        }
      }
    }).catchError((onError) async {});
  }

  void submit(BuildContext ctx) async {
    setState(() {
      isLoading = true;
    });

    {
      mapCountry.forEach((key, value) {
        if (key == selectCountry) country = value;
      });
      mapState.forEach((key, value) {
        if (key == selectState) state = value;
      });

      BusinessLocationDetail businessContactDetail = BusinessLocationDetail();
      businessContactDetail.businessId = basicInfo!.businessId;
      businessContactDetail.address = controller2.text;
      businessContactDetail.country = country;
      businessContactDetail.state = state;
      businessContactDetail.postalCode = pinController.text;
      businessContactDetail.city = cityMapController.text;
      businessContactDetail.lat = lat.toString();
      businessContactDetail.lon = lon.toString();

      Calls()
          .call(jsonEncode(businessContactDetail), context,
              isEdit ? basicInfo!.editLocation : basicInfo!.addLocation)
          .then((value) async {
        setState(() {
          isLoading = false;
        });
        if (value != null) {
          var data = BaseResponse.fromJson(value);
          if (data.statusCode == basicInfo!.statusCode) {
            Navigator.pop(context);
            widget.refreshCallBack();
          }
        }
      }).catchError((onError) {
        setState(() {
          isLoading = false;
        });
        ToastBuilder().showToast(
            onError.toString(), context, HexColor(AppColors.information));
      });
    }
  }
}
