import 'package:flutter/material.dart';
import 'package:loyalty_management_tool/bloc/common_widgets/rewards_widget.dart';
import 'package:loyalty_management_tool/models/rewards_list_response.dart';
import 'package:loyalty_management_tool/utils/custom_app_bar.dart';
import 'package:loyalty_management_tool/utils/localization.dart';

class RewardsDetailPage extends StatefulWidget {
  final RewardsItem item;
  final Function(RewardsItem? item) editCallBack;
  final Function(int? id) deleteCallBack;

  const RewardsDetailPage(
      {Key? key,
      required this.item,
      required this.editCallBack,
      required this.deleteCallBack})
      : super(key: key);

  @override
  RewardsDetailPageState createState() => RewardsDetailPageState();
}

class RewardsDetailPageState extends State<RewardsDetailPage> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: appAppBar().getCustomAppBar(
          context,
          appBarTitle: AppLocalizationsRewards.of(context)!.translate("detail"),
          onBackButtonPress: () {
            Navigator.pop(context);
          },
        ),
        body: SingleChildScrollView(
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              RewardsWidget(
                isDetailPage: true,
                item: widget.item,
                deleteCallBack: (id) {
                  widget.deleteCallBack(id);
                },
                editCallBack: (item) {
                  widget.editCallBack(widget.item);
                },
              ),
            ],
          ),
        ));
  }
}
