class RedemptionResponse {
  String? statusCode;
  String? message;
  RedemptionItem? rows;
  int? total;

  RedemptionResponse({this.statusCode, this.message, this.rows, this.total});

  RedemptionResponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null ? RedemptionItem.fromJson(json['rows']) : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class RedemptionItem {
  num? couponDiscountPercentage;
  num? couponCoinsForDiscountPercentage;
  num? giftCash;
  num? giftCoinsForCash;
  int? businessId;

  RedemptionItem(
      {this.couponDiscountPercentage,
      this.couponCoinsForDiscountPercentage,
      this.giftCash,
      this.businessId,
      this.giftCoinsForCash});

  RedemptionItem.fromJson(Map<String, dynamic> json) {
    businessId = json['business_id'];
    couponDiscountPercentage = json['coupon_discount_percentage'];
    couponCoinsForDiscountPercentage =
        json['coupon_coins_for_discount_percentage'];
    giftCash = json['gift_cash'];
    giftCoinsForCash = json['gift_coins_for_cash'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['business_id'] = businessId;
    data['coupon_discount_percentage'] = this.couponDiscountPercentage;
    data['coupon_coins_for_discount_percentage'] =
        this.couponCoinsForDiscountPercentage;
    data['gift_cash'] = this.giftCash;
    data['gift_coins_for_cash'] = this.giftCoinsForCash;
    return data;
  }
}
