class CartViewRespponse {
  String? statusCode;
  String? message;
  Rows? rows;
  int? total;

  CartViewRespponse({this.statusCode, this.message, this.rows, this.total});

  CartViewRespponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null ? new Rows.fromJson(json['rows']) : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class Rows {
  int? id;
  String? orderByType;
  int? orderById;
  int? businessId;
  String? orderStatus;
  int? orderAmount;
  int? taxAmount;
  int? discountAmount;
  int? serviceChargeAmount;
  int? payableAmount;
  TaxOtherDetails? taxOtherDetails;
  List<OrderItems>? orderItems;

  Rows(
      {this.id,
      this.orderByType,
      this.orderById,
      this.businessId,
      this.orderStatus,
      this.orderAmount,
      this.taxAmount,
      this.discountAmount,
      this.serviceChargeAmount,
      this.payableAmount,
      this.taxOtherDetails,
      this.orderItems});

  Rows.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    orderByType = json['order_by_type'];
    orderById = json['order_by_id'];
    businessId = json['business_id'];
    orderStatus = json['order_status'];
    orderAmount = json['order_amount'];
    taxAmount = json['tax_amount'];
    discountAmount = json['discount_amount'];
    serviceChargeAmount = json['service_charge_amount'];
    payableAmount = json['payable_amount'];
    taxOtherDetails = json['tax_other_details'] != null
        ? new TaxOtherDetails.fromJson(json['tax_other_details'])
        : null;
    if (json['order_items'] != null) {
      orderItems = <OrderItems>[];
      json['order_items'].forEach((v) {
        orderItems!.add(new OrderItems.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['order_by_type'] = this.orderByType;
    data['order_by_id'] = this.orderById;
    data['business_id'] = this.businessId;
    data['order_status'] = this.orderStatus;
    data['order_amount'] = this.orderAmount;
    data['tax_amount'] = this.taxAmount;
    data['discount_amount'] = this.discountAmount;
    data['service_charge_amount'] = this.serviceChargeAmount;
    data['payable_amount'] = this.payableAmount;
    if (this.taxOtherDetails != null) {
      data['tax_other_details'] = this.taxOtherDetails!.toJson();
    }
    if (this.orderItems != null) {
      data['order_items'] = this.orderItems!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class TaxOtherDetails {
  Null? gst;
  Null? cgst;
  Null? sgst;
  Null? igst;
  int? serviceCharge;
  bool? isServiceChargPercentage;

  TaxOtherDetails(
      {this.gst,
      this.cgst,
      this.sgst,
      this.igst,
      this.serviceCharge,
      this.isServiceChargPercentage});

  TaxOtherDetails.fromJson(Map<String, dynamic> json) {
    gst = json['gst'];
    cgst = json['cgst'];
    sgst = json['sgst'];
    igst = json['igst'];
    serviceCharge = json['service_charge'];
    isServiceChargPercentage = json['is_service_charg_percentage'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['gst'] = this.gst;
    data['cgst'] = this.cgst;
    data['sgst'] = this.sgst;
    data['igst'] = this.igst;
    data['service_charge'] = this.serviceCharge;
    data['is_service_charg_percentage'] = this.isServiceChargPercentage;
    return data;
  }
}

class OrderItems {
  int? id;
  String? itemType;
  Null? itemTypeId;
  String? itemDescription;
  Null? itemImageUrl;
  int? itemAmount;
  int? taxAmount;
  int? discountAmount;
  int? itemQuantity;
  int? totalAmount;
  bool? isActive;

  OrderItems(
      {this.id,
      this.itemType,
      this.itemTypeId,
      this.itemDescription,
      this.itemImageUrl,
      this.itemAmount,
      this.taxAmount,
      this.discountAmount,
      this.itemQuantity,
      this.totalAmount,
      this.isActive});

  OrderItems.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    itemType = json['item_type'];
    itemTypeId = json['item_type_id'];
    itemDescription = json['item_description'];
    itemImageUrl = json['item_image_url'];
    itemAmount = json['item_amount'];
    taxAmount = json['tax_amount'];
    discountAmount = json['discount_amount'];
    itemQuantity = json['item_quantity'];
    totalAmount = json['total_amount'];
    isActive = json['is_active'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['item_type'] = this.itemType;
    data['item_type_id'] = this.itemTypeId;
    data['item_description'] = this.itemDescription;
    data['item_image_url'] = this.itemImageUrl;
    data['item_amount'] = this.itemAmount;
    data['tax_amount'] = this.taxAmount;
    data['discount_amount'] = this.discountAmount;
    data['item_quantity'] = this.itemQuantity;
    data['total_amount'] = this.totalAmount;
    data['is_active'] = this.isActive;
    return data;
  }
}
