class CreateOrderResponse {
  String? statusCode;
  String? message;
  Rows? rows;
  int? total;

  CreateOrderResponse({this.statusCode, this.message, this.rows, this.total});

  CreateOrderResponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null ? new Rows.fromJson(json['rows']) : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class Rows {
  String? orderNumber;
  int? id;

  Rows({this.orderNumber, this.id});

  Rows.fromJson(Map<String, dynamic> json) {
    orderNumber = json['order_number'];
    id = json['id'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['order_number'] = this.orderNumber;
    data['id'] = this.id;
    return data;
  }
}
