import 'package:loyalty_management_tool/models/postcreate.dart';
import 'package:loyalty_management_tool/models/rewards_list_response.dart';

class CreateRewardResponse {
  String? statusCode;
  String? message;
  Rows? rows;
  int? total;

  CreateRewardResponse({this.statusCode, this.message, this.rows, this.total});

  CreateRewardResponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null ? new Rows.fromJson(json['rows']) : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class Rows {
  int? businessId;
  int? standardLoyaltyProgramTypesId;

  String? title;
  String? subtitle;
  List<String>? recipientType;
  List<NormalReceivers2>? recipientDetails;
  num? startDatetime;
  num? endDatetime;
  int? incentiveCoins;
  int? incentiveCash;
  String? incentiveCurrency;
  RedemptionDetails? redemptionDetails;
  String? status;
  int? id;

  Rows(
      {this.businessId,
      this.standardLoyaltyProgramTypesId,
      this.title,
      this.subtitle,
      this.recipientType,
      this.recipientDetails,
      this.startDatetime,
      this.endDatetime,
      this.incentiveCoins,
      this.incentiveCash,
      this.incentiveCurrency,
      this.redemptionDetails,
      this.status,
      this.id});

  Rows.fromJson(Map<String, dynamic> json) {
    businessId = json['business_id'];
    standardLoyaltyProgramTypesId = json['standard_loyalty_program_types_id'];

    title = json['title'];
    subtitle = json['subtitle'];
    recipientType = json['recipient_type'].cast<String>();
    if (json['recipient_details'] != null) {
      recipientDetails = <NormalReceivers2>[];
      json['recipient_details'].forEach((v) {
        recipientDetails!.add(NormalReceivers2.fromJson(v));
      });
    }
    startDatetime = json['start_datetime'];
    endDatetime = json['end_datetime'];
    incentiveCoins = json['incentive_coins'];
    incentiveCash = json['incentive_cash'];
    incentiveCurrency = json['incentive_currency'];
    redemptionDetails = json['redemption_details'] != null
        ? new RedemptionDetails.fromJson(json['redemption_details'])
        : null;
    status = json['status'];
    id = json['id'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['business_id'] = this.businessId;
    data['standard_loyalty_program_types_id'] =
        this.standardLoyaltyProgramTypesId;

    data['title'] = this.title;
    data['subtitle'] = this.subtitle;
    data['recipient_type'] = this.recipientType;
    if (this.recipientDetails != null) {
      data['recipient_details'] =
          this.recipientDetails!.map((v) => v.toJson()).toList();
    }
    data['start_datetime'] = this.startDatetime;
    data['end_datetime'] = this.endDatetime;
    data['incentive_coins'] = this.incentiveCoins;
    data['incentive_cash'] = this.incentiveCash;
    data['incentive_currency'] = this.incentiveCurrency;
    if (this.redemptionDetails != null) {
      data['redemption_details'] = this.redemptionDetails!.toJson();
    }
    data['status'] = this.status;
    data['id'] = this.id;
    return data;
  }
}
