class PaymentTokenResponse {
  String? statusCode;
  String? message;
  PaymentTokenRow? rows;
  int? total;

  PaymentTokenResponse({this.statusCode, this.message, this.rows, this.total});

  PaymentTokenResponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null
        ? new PaymentTokenRow.fromJson(json['rows'])
        : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class PaymentTokenRow {
  String? status;
  String? message;
  String? cftoken;

  PaymentTokenRow({this.status, this.message, this.cftoken});

  PaymentTokenRow.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    message = json['message'];
    cftoken = json['cftoken'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['message'] = this.message;
    data['cftoken'] = this.cftoken;
    return data;
  }
}
