class SettingViewResponse {
  String? statusCode;
  String? message;
  Rows? rows;
  num? total;

  SettingViewResponse({this.statusCode, this.message, this.rows, this.total});

  SettingViewResponse.fromJson(Map<String, dynamic> json) {
    statusCode = json['statusCode'];
    message = json['message'];
    rows = json['rows'] != null ? new Rows.fromJson(json['rows']) : null;
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['statusCode'] = this.statusCode;
    data['message'] = this.message;
    if (this.rows != null) {
      data['rows'] = this.rows!.toJson();
    }
    data['total'] = this.total;
    return data;
  }
}

class Rows {
  num? id;
  Null? businessId;
  num? minCash;
  num? minCoins;
  num? serviceChargePerXCoins;

  Rows(
      {this.id,
      this.businessId,
      this.minCash,
      this.minCoins,
      this.serviceChargePerXCoins});

  Rows.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    businessId = json['business_id'];
    minCash = json['min_cash'];
    minCoins = json['min_coins'];
    serviceChargePerXCoins = json['service_charge_per_x_coins'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['business_id'] = this.businessId;
    data['min_cash'] = this.minCash;
    data['min_coins'] = this.minCoins;
    data['service_charge_per_x_coins'] = this.serviceChargePerXCoins;
    return data;
  }
}
